diff --git a/target/linux/airoha/Makefile b/target/linux/airoha/Makefile
index 723bec8cd434..61b47b0ca2ba 100644
--- a/target/linux/airoha/Makefile
+++ b/target/linux/airoha/Makefile
@@ -4,7 +4,7 @@ ARCH:=arm
 BOARD:=airoha
 BOARDNAME:=Airoha ARM
 CPU_TYPE:=cortex-a7
-FEATURES:=dt squashfs nand ramdisk gpio source-only
+FEATURES:=dt squashfs nand ramdisk gpio source-only grand_flash
 
 KERNEL_PATCHVER:=5.15
 
diff --git a/target/linux/armsr/Makefile b/target/linux/armsr/Makefile
index b34500ed8a59..aabf3570e163 100644
--- a/target/linux/armsr/Makefile
+++ b/target/linux/armsr/Makefile
@@ -7,7 +7,7 @@ include $(TOPDIR)/rules.mk
 BOARD:=armsr
 BOARDNAME:=Arm SystemReady (EFI) compliant
 FEATURES:=fpu pci pcie rtc usb boot-part rootfs-part
-FEATURES+=cpiogz ext4 ramdisk squashfs targz vmdk
+FEATURES+=cpiogz ext4 ramdisk squashfs targz vmdk grand_flash
 
 KERNEL_PATCHVER:=6.1
 
diff --git a/target/linux/bcm27xx/Makefile b/target/linux/bcm27xx/Makefile
index 3f9efb9f008a..5fa090324c08 100644
--- a/target/linux/bcm27xx/Makefile
+++ b/target/linux/bcm27xx/Makefile
@@ -8,7 +8,8 @@ include $(TOPDIR)/rules.mk
 ARCH:=arm
 BOARD:=bcm27xx
 BOARDNAME:=Broadcom BCM27xx
-FEATURES:=audio boot-part display ext4 fpu gpio rootfs-part rtc squashfs usb usbgadget wireless
+FEATURES:=audio boot-part display ext4 fpu gpio
+FEATURES+=rootfs-part rtc squashfs usb usbgadget wireless grand_flash
 SUBTARGETS:=bcm2708 bcm2709 bcm2710 bcm2711
 
 KERNEL_PATCHVER:=6.1
diff --git a/target/linux/bcm4908/Makefile b/target/linux/bcm4908/Makefile
index 2d848b50c69a..59fece1f94ab 100644
--- a/target/linux/bcm4908/Makefile
+++ b/target/linux/bcm4908/Makefile
@@ -5,7 +5,7 @@ include $(TOPDIR)/rules.mk
 ARCH:=aarch64
 BOARD:=bcm4908
 BOARDNAME:=Broadcom BCM4908 (ARMv8A CPUs Brahma-B53)
-FEATURES:=squashfs nand usb gpio
+FEATURES:=squashfs nand usb gpio grand_flash
 CPU_TYPE:=cortex-a53
 SUBTARGETS:=generic
 
diff --git a/target/linux/gemini/Makefile b/target/linux/gemini/Makefile
index 284d1247cb23..4d533cb96da3 100644
--- a/target/linux/gemini/Makefile
+++ b/target/linux/gemini/Makefile
@@ -7,7 +7,7 @@ include $(TOPDIR)/rules.mk
 ARCH:=arm
 BOARD:=gemini
 BOARDNAME:=Cortina Systems CS351x
-FEATURES:=squashfs pci rtc usb dt gpio display ext4 rootfs-part boot-part
+FEATURES:=squashfs pci rtc usb dt gpio display ext4 rootfs-part boot-part grand_flash
 CPU_TYPE:=fa526
 SUBTARGETS:=generic
 
diff --git a/target/linux/ipq806x/Makefile b/target/linux/ipq806x/Makefile
index 3ebf17c933f6..b47df88ee56f 100644
--- a/target/linux/ipq806x/Makefile
+++ b/target/linux/ipq806x/Makefile
@@ -5,7 +5,7 @@ include $(TOPDIR)/rules.mk
 ARCH:=arm
 BOARD:=ipq806x
 BOARDNAME:=Qualcomm Atheros IPQ806X
-FEATURES:=squashfs fpu ramdisk wireless
+FEATURES:=squashfs fpu ramdisk wireless grand_flash
 CPU_TYPE:=cortex-a15
 CPU_SUBTYPE:=neon-vfpv4
 SUBTARGETS:=generic chromium
diff --git a/target/linux/ipq807x/Makefile b/target/linux/ipq807x/Makefile
index a16ecf4c8abc..8e1567afdf03 100644
--- a/target/linux/ipq807x/Makefile
+++ b/target/linux/ipq807x/Makefile
@@ -3,7 +3,7 @@ include $(TOPDIR)/rules.mk
 ARCH:=aarch64
 BOARD:=ipq807x
 BOARDNAME:=Qualcomm Atheros IPQ807x
-FEATURES:=squashfs ramdisk fpu nand rtc emmc wireless
+FEATURES:=squashfs ramdisk fpu nand rtc emmc wireless grand_flash
 KERNELNAME:=Image dtbs
 CPU_TYPE:=cortex-a53
 SUBTARGETS:=generic
diff --git a/target/linux/layerscape/Makefile b/target/linux/layerscape/Makefile
index 23672602529e..735971226953 100644
--- a/target/linux/layerscape/Makefile
+++ b/target/linux/layerscape/Makefile
@@ -9,7 +9,7 @@ BOARDNAME:=NXP Layerscape
 
 KERNEL_PATCHVER:=5.15
 
-FEATURES:=squashfs nand usb pcie gpio fpu ubifs ext4 rootfs-part boot-part
+FEATURES:=squashfs nand usb pcie gpio fpu ubifs ext4 rootfs-part boot-part grand_flash
 SUBTARGETS:=armv8_64b armv7
 
 define Target/Description
diff --git a/target/linux/malta/Makefile b/target/linux/malta/Makefile
index 537c2966a233..13306752f99b 100644
--- a/target/linux/malta/Makefile
+++ b/target/linux/malta/Makefile
@@ -8,7 +8,7 @@ BOARD:=malta
 BOARDNAME:=MIPS Malta CoreLV board (qemu)
 SUBTARGETS:=le be le64 be64
 INITRAMFS_EXTRA_FILES:=
-FEATURES:=cpiogz ext4 ramdisk squashfs targz wireless
+FEATURES:=cpiogz ext4 ramdisk squashfs targz wireless grand_flash
 
 KERNEL_PATCHVER:=5.15
 KERNEL_TESTING_PATCHVER:=6.1
diff --git a/target/linux/mediatek/Makefile b/target/linux/mediatek/Makefile
index 65401131365d..17936bd0e3a2 100644
--- a/target/linux/mediatek/Makefile
+++ b/target/linux/mediatek/Makefile
@@ -6,7 +6,8 @@ ARCH:=arm
 BOARD:=mediatek
 BOARDNAME:=MediaTek Ralink ARM
 SUBTARGETS:=mt7622 mt7623 mt7629 filogic
-FEATURES:=dt-overlay emmc fpu gpio nand pci pcie rootfs-part separate_ramdisk squashfs usb wireless
+FEATURES:=dt-overlay emmc fpu gpio nand pci pcie rootfs-part
+FEATURES+=separate_ramdisk squashfs usb wireless grand_flash
 
 KERNEL_PATCHVER:=5.15
 
diff --git a/target/linux/qoriq/Makefile b/target/linux/qoriq/Makefile
index 5e8e417d3f47..7d097528e5ab 100644
--- a/target/linux/qoriq/Makefile
+++ b/target/linux/qoriq/Makefile
@@ -8,7 +8,8 @@ ARCH:=powerpc64
 BOARD:=qoriq
 BOARDNAME:=NXP QorIQ (PowerPC)
 CPU_TYPE:=e5500
-FEATURES:=boot-part ext4 fpu legacy-sdcard powerpc64 ramdisk rootfs-part rtc source-only
+FEATURES:=boot-part ext4 fpu legacy-sdcard powerpc64 ramdisk
+FEATURES+=rootfs-part rtc source-only grand_flash
 SUBTARGETS:=generic
 
 KERNEL_PATCHVER:=5.15
diff --git a/target/linux/rockchip/Makefile b/target/linux/rockchip/Makefile
index f17f0bdf4908..a2ec7967f282 100644
--- a/target/linux/rockchip/Makefile
+++ b/target/linux/rockchip/Makefile
@@ -4,7 +4,8 @@ include $(TOPDIR)/rules.mk
 
 BOARD:=rockchip
 BOARDNAME:=Rockchip
-FEATURES:=ext4 audio usb usbgadget display gpio fpu pci pcie rootfs-part boot-part squashfs
+FEATURES:=ext4 audio usb usbgadget display gpio fpu pci pcie
+FEATURES+=rootfs-part boot-part squashfs grand_flash
 SUBTARGETS:=armv8
 
 KERNEL_PATCHVER:=5.15
diff --git a/target/linux/sifiveu/Makefile b/target/linux/sifiveu/Makefile
index f88164e7af33..eb4a5a776e6f 100644
--- a/target/linux/sifiveu/Makefile
+++ b/target/linux/sifiveu/Makefile
@@ -7,7 +7,7 @@ include $(TOPDIR)/rules.mk
 ARCH:=riscv64
 BOARD:=sifiveu
 BOARDNAME:=SiFive U-based RISC-V boards
-FEATURES:=ext4
+FEATURES:=ext4 grand_flash
 KERNELNAME:=Image dtbs
 SUBTARGETS:=generic
 
diff --git a/target/linux/sunxi/Makefile b/target/linux/sunxi/Makefile
index 02cf0ddbb18b..cc5706b03869 100644
--- a/target/linux/sunxi/Makefile
+++ b/target/linux/sunxi/Makefile
@@ -7,7 +7,7 @@ include $(TOPDIR)/rules.mk
 ARCH:=arm
 BOARD:=sunxi
 BOARDNAME:=Allwinner A1x/A20/A3x/H3/H5/R40
-FEATURES:=fpu usb ext4 display rootfs-part rtc squashfs wireless
+FEATURES:=fpu usb ext4 display rootfs-part rtc squashfs wireless grand_flash
 SUBTARGETS:=cortexa8 cortexa7 cortexa53
 
 KERNEL_PATCHVER:=5.15
diff --git a/target/linux/tegra/Makefile b/target/linux/tegra/Makefile
index 62c48a11d067..a32ec2a64013 100644
--- a/target/linux/tegra/Makefile
+++ b/target/linux/tegra/Makefile
@@ -7,7 +7,8 @@ include $(TOPDIR)/rules.mk
 ARCH := arm
 BOARD := tegra
 BOARDNAME := NVIDIA Tegra
-FEATURES := audio boot-part display ext4 fpu gpio pci pcie rootfs-part rtc squashfs usb wireless
+FEATURES := audio boot-part display ext4 fpu gpio pci pcie
+FEATURES += rootfs-part rtc squashfs usb wireless grand_flash
 CPU_TYPE := cortex-a9
 CPU_SUBTYPE := vfpv3-d16
 SUBTARGETS := generic
diff --git a/target/linux/uml/Makefile b/target/linux/uml/Makefile
index 803ed3ac39b1..acab3cec4612 100644
--- a/target/linux/uml/Makefile
+++ b/target/linux/uml/Makefile
@@ -11,7 +11,7 @@ ifeq ($(HOST_OS),Linux)
 ARCH:=x86_64
 BOARD:=uml
 BOARDNAME:=User Mode Linux
-FEATURES:=audio ext4 rootfs-part squashfs wireless
+FEATURES:=audio ext4 rootfs-part squashfs wireless grand_flash
 
 KERNEL_PATCHVER:=5.15
 KERNEL_TESTING_PATCHVER:=6.1
diff --git a/target/linux/x86/Makefile b/target/linux/x86/Makefile
index 5368a779e54f..8bdfe54fd45f 100644
--- a/target/linux/x86/Makefile
+++ b/target/linux/x86/Makefile
@@ -7,7 +7,7 @@ include $(TOPDIR)/rules.mk
 ARCH:=i386
 BOARD:=x86
 BOARDNAME:=x86
-FEATURES:=squashfs ext4 vdi vmdk vhdx pcmcia targz fpu boot-part rootfs-part
+FEATURES:=squashfs ext4 vdi vmdk vhdx pcmcia targz fpu boot-part rootfs-part grand_flash
 SUBTARGETS:=generic legacy geode 64
 
 KERNEL_PATCHVER:=5.15
diff --git a/target/linux/zynq/Makefile b/target/linux/zynq/Makefile
index f48b58e59824..0de2a9967855 100644
--- a/target/linux/zynq/Makefile
+++ b/target/linux/zynq/Makefile
@@ -7,7 +7,7 @@ include $(TOPDIR)/rules.mk
 ARCH:=arm
 BOARD:=zynq
 BOARDNAME:=Xilinx Zynq 7000 SoCs
-FEATURES:=fpu gpio rtc usb usbgadget boot-part rootfs-part squashfs
+FEATURES:=fpu gpio rtc usb usbgadget boot-part rootfs-part squashfs grand_flash
 CPU_TYPE:=cortex-a9
 CPU_SUBTYPE:=neon
 SUBTARGETS:=generic